* encode base64 line
*
* this source is 'free' and 'not guaranteed'
* 15, Feb, 2000 Rick <shonma@geocities.co.jp>
*
* (usege)
*	int encbenc(char *dest, char *src, int size);
*
* (arguments)
*	dest ... pointer to destination buffer
*	src  ... pointer to source buffer
*	int  ... number of bytes to encode
*
* (return value)
*	number of processed characters
*

	.cpu 68000

	.text

	.even
	.globl _encbenc
_encbenc:
	movem.l	4(sp),a0/a1/a2	*w = dest, r = src, size
	move.l	d3,-(sp)
	move.l	a2,d2		*size
	lea.l	b64tbl(OPC),a2
	bra	loop_ent
loop:
	move.b	(a1)+,d0	*c = r[0]
	swap	d0		*c = c << 16
	subq.w	#1,d2		*--size > 0 ?
	ble	@f

	movep.w	(a1),d0		*c |= r[1] << 8
@@
	subq.w	#1,d2		*--size > 0 ?
	ble	@f

	move.b	1(a1),d0	*c |= r[2]
@@
	addq.w	#2,a1		*r += 3
	swap.w	d0
	ror.l	#2,d0		*c >> 18
	moveq.l	#63,d1
	and.w	d0,d1
	move.b	(a2,d1.w),(a0)+	* *w++ = b64tbl[(c >> 18) & 63]

	rol.l	#6,d0
	moveq.l	#63,d1
	and.w	d0,d1
	move.b	(a2,d1.w),(a0)+	* *w++ = b64tbl[(c >> 12) & 63]

	moveq.l	#'=',d3
	tst.w	d2		*size < 0 ?
	bmi	@f

	rol.l	#6,d0
	moveq.l	#63,d1
	and.w	d0,d1
	move.b	(a2,d1.w),d3
@@
	move.b	d3,(a0)+	* *w++ = b64tbl[(c >> 6) & 63]

	moveq.l	#'=',d3
	subq.w	#1,d2		*--size < 0 ?
	bmi	@f

	rol.l	#6,d0
	andi.w	#63,d0
	move.b	(a2,d0.w),d3
@@
	move.b	d3,(a0)+	* *w++ = b64tbl[c & 63]
	tst.w	d2		*size > 0 ?
loop_ent:
	bgt	loop

	clr.b	(a0)
	move.l	(sp)+,d3

*set return value
	move.l	a0,d0		*w
	sub.l	4(sp),d0	*w - dest
	rts

	.even
b64tbl:
	.dc.b	'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'

	.even
	.end
