/* phantom.h */

/* 萔錾 */

#define	VERSION "0.20"

#ifndef TRUE
#define	TRUE	1
#endif

#ifndef FALSE
#define FALSE	0
#endif

#define __DOS_INLINE__

#define STR_LEN	1024	/* ϐmۂ̒ */
#define FILE_LEN	128	/* t@Cmۂ镶̒ */
#define SET_LEN		128	/* ̂ق̐ݒŎg̒ */

#define SINGLE -1
#define MULTI 0

#define UNDECIDED -1

/* \̒` */

/* mimetype.c */
struct _chain {
	struct _chain *next;
	char body[1];
};

struct _typeext {
	char *name;
	char *mimetype;
};

struct _typelist {
	int current;
	int max;
	struct _chain *head;
	struct _typeext list[1];
};


/* mqueue.c */
struct _sendfile {
	struct _sendfile *next;		/* Xg̗̎vf */
	char complete;				/* [o͌ */
	char line[1];				/* [ */
};

struct _mqueue {
	int entry;					/* [Xg */
	int newfile;				/* o̓t@C */
	struct _sendfile *head;		/* [Xg */
	struct _chain *ahead;		/* Ytt@CXg */
	struct _typelist *thead;	/* mimetype Xg */
	char *boundary;				/* multipart E */
	char indirect[FILE_LEN];	/* Ԑڃt@C */
	char qdir[FILE_LEN];		/* o̓fBNg */
	char home[FILE_LEN];		/* HOMEfBNg */
	char Key[SET_LEN];			/* ݒ荀ڃL[ */
	char MailAdress[SET_LEN];	/* ̃[AhX */
	char MailName[SET_LEN];		/* ̖O */
	char signature[STR_LEN];	/* t@C̓e */
	char putdate;				/* Date: o͂邩 */
	char putsign;				/* o͂邩 */
};


/* O[oϐ */

/* IvV */
char Verbose;					/* ׂ胂[hݒ */


/* ֐vg^Cv */

/* mqueue.c */
int Get_SmailRc (struct _mqueue *q);
struct _mqueue *create_queue ();
int indirect_queue (struct _mqueue *q, char *filename);
int add_queue (struct _mqueue *q, char *str, int mode);
int destroy_queue (struct _mqueue *q);
char *getenvdir (char *dest, char *envname);

/* mailio.c */
void SendMail (struct _mqueue *q);

/* fgets822a.c */
int fgets822a (char *buf, int size, FILE *fp);

/* mimetype.c */
void destroy_chain (struct _chain **ahead);
void destroy_mimetype (struct _typelist **tlist);
struct _typelist *read_mimetype ();
char *search_mimetype (struct _typelist *t, char *fname);

/* attach.c */
#define destroy_attach destroy_chain

int add_attach (struct _chain **ahead, char *fname);
void put_attach (FILE *outfp, struct _chain *attachlist,
				struct _typelist *mimetype, char *boundary);
char *create_boundary ();


/* GetKeyword.s */
char *GetKeyword (char *str, char *key);

/* sjis2jis.s */
int sjis2jis (char *dest, char *src);
char codetype[];

/* encbenc.s */
int encbenc (char *dest, char *src, int);

/* jis2mimeB.s */
char *jis2mimeB (char *dest, char *src);
